summaryrefslogtreecommitdiffstats
path: root/shell-completion
diff options
context:
space:
mode:
Diffstat (limited to 'shell-completion')
-rw-r--r--shell-completion/bash/dracut124
-rw-r--r--shell-completion/bash/lsinitrd71
2 files changed, 195 insertions, 0 deletions
diff --git a/shell-completion/bash/dracut b/shell-completion/bash/dracut
new file mode 100644
index 0000000..e8a8691
--- /dev/null
+++ b/shell-completion/bash/dracut
@@ -0,0 +1,124 @@
+#!/bin/bash
+# Copyright 2013 Red Hat, Inc. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+__contains_word() {
+ local word="$1"
+ shift
+ for w in "$@"; do [[ $w == "$word" ]] && return 0; done
+ return 1
+}
+
+_dracut() {
+ local cur=${COMP_WORDS[COMP_CWORD]} prev=${COMP_WORDS[COMP_CWORD - 1]}
+ local -A OPTS=(
+ [STANDALONE]='-f -v -q -l -H -h -M -N -p
+ --ro-mnt --force --kernel-only --no-kernel --strip --nostrip
+ --hardlink --nohardlink --noprefix --mdadmconf --nomdadmconf
+ --lvmconf --nolvmconf --debug --profile --verbose --quiet
+ --local --hostonly --no-hostonly --fstab --help --bzip2 --lzma
+ --xz --zstd --no-compress --gzip --list-modules --show-modules --keep
+ --printsize --regenerate-all --noimageifnotneeded --early-microcode
+ --no-early-microcode --print-cmdline --reproducible --uefi
+ --enhanced-cpio --rebuild --aggressive-strip --hostonly-cmdline
+ --no-hostonly-cmdline --no-hostonly-default-device --nofscks
+ --hostonly-i18n --no-hostonly-i18n --lzo --lz4 --no-reproducible
+ --no-uefi --no-machineid --version --parallel
+ '
+ [ARG]='-a -m -o -d -I -k -c -L -r -i
+ --kver --add --force-add --add-drivers --force-drivers
+ --omit-drivers --modules --omit --drivers --filesystems --install
+ --fwdir --libdirs --fscks --add-fstab --mount --device
+ --kmoddir --conf --confdir --tmpdir --stdlog --compress --prefix
+ --kernel-cmdline --sshkey --persistent-policy --install-optional
+ --loginstall --uefi-stub --kernel-image --squash-compressor
+ --sysroot --hostonly-mode --hostonly-nics --include --logfile
+ --uefi-splash-image --sbat
+ '
+ )
+
+ # shellcheck disable=SC2086
+ if __contains_word "$prev" ${OPTS[ARG]}; then
+ case $prev in
+ --kmoddir | -k | --fwdir | --confdir | --tmpdir | -r | --sysroot)
+ comps=$(compgen -d -- "$cur")
+ compopt -o filenames
+ ;;
+ -c | --conf | --sshkey | --add-fstab | --add-device | -I | \
+ --install | --install-optional | --uefi-splash-image)
+ comps=$(compgen -f -- "$cur")
+ compopt -o filenames
+ ;;
+ -a | -m | -o | --add | --modules | --omit)
+ comps=$(dracut --list-modules 2> /dev/null)
+ ;;
+ --persistent-policy)
+ comps=$(
+ cd /dev/disk/ || return 0
+ printf -- "%s " *
+ )
+ ;;
+ --kver)
+ comps=$(
+ cd /lib/modules || return 0
+ echo [0-9]*
+ )
+ ;;
+ --hostonly-mode)
+ comps="sloppy strict"
+ ;;
+ --hostonly-nics)
+ comps=$(
+ cd /sys/class/net/ || return 0
+ printf -- "%s " *
+ )
+ ;;
+ *)
+ return 0
+ ;;
+ esac
+ # shellcheck disable=SC2207
+ # shellcheck disable=SC2016
+ COMPREPLY=($(compgen -W '$comps' -- "$cur"))
+ return 0
+ fi
+
+ if [[ $cur == -* ]]; then
+ # shellcheck disable=SC2207
+ # shellcheck disable=SC2016
+ COMPREPLY=($(compgen -W '${OPTS[*]}' -- "$cur"))
+ return 0
+ fi
+
+ local args
+ _count_args
+ if [[ $args -eq 1 ]]; then
+ _filedir
+ return 0
+ elif [[ $args -eq 2 ]]; then
+ # shellcheck disable=SC2034
+ comps=$(
+ cd /lib/modules || return 0
+ echo [0-9]*
+ )
+ # shellcheck disable=SC2207
+ # shellcheck disable=SC2016
+ COMPREPLY=($(compgen -W '$comps' -- "$cur"))
+ return 0
+ fi
+}
+
+complete -F _dracut dracut
diff --git a/shell-completion/bash/lsinitrd b/shell-completion/bash/lsinitrd
new file mode 100644
index 0000000..da7e7ad
--- /dev/null
+++ b/shell-completion/bash/lsinitrd
@@ -0,0 +1,71 @@
+#!/bin/bash
+# Copyright 2013 Red Hat, Inc. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+__contains_word() {
+ local word="$1"
+ shift
+ for w in "$@"; do [[ $w == "$word" ]] && return 0; done
+ return 1
+}
+
+_lsinitrd() {
+ local cur=${COMP_WORDS[COMP_CWORD]} prev=${COMP_WORDS[COMP_CWORD - 1]}
+ local -A OPTS=(
+ [STANDALONE]='-s --size -h --help --unpack --unpackearly -v --verbose'
+ [ARG]='-f --file -k --kver'
+ )
+
+ # shellcheck disable=SC2086
+ if __contains_word "$prev" ${OPTS[ARG]}; then
+ case $prev in
+ --file | -f)
+ comps=$(compgen -f -- "$cur")
+ compopt -o filenames
+ ;;
+ --kver | -k)
+ comps=$(
+ cd /lib/modules || return 1
+ echo [0-9]*
+ )
+ ;;
+ *)
+ return 0
+ ;;
+ esac
+ # shellcheck disable=SC2207
+ # shellcheck disable=SC2016
+ COMPREPLY=($(compgen -W '$comps' -- "$cur"))
+ return 0
+ fi
+
+ if [[ $cur == -* ]]; then
+ # shellcheck disable=SC2207
+ # shellcheck disable=SC2016
+ COMPREPLY=($(compgen -W '${OPTS[*]}' -- "$cur"))
+ return 0
+ fi
+
+ # shellcheck disable=SC2034
+ comps=$(compgen -f -- "$cur")
+ compopt -o filenames
+ # shellcheck disable=SC2207
+ # shellcheck disable=SC2016
+ COMPREPLY=($(compgen -W '$comps' -- "$cur"))
+ return 0
+}
+
+complete -F _lsinitrd lsinitrd